(in-package :translate)

(def-411-trap getvideodefault :number '41088 :entry 'nil :exit 'nil) 

(def-411-trap killio :number '40966 :entry 'nil :exit 'nil) 

(def-411-trap handlezone :number
  '41254
  :entry
  '((:a0 (h handle)))
  :exit
  '((:a0 (function result pointer)) (:d0 (result code word)))) 

(def-411-trap gettrapaddress :number
  '41286
  :entry
  '((:d0 (trapnum word)))
  :exit
  '((:a0 (address of routine)))) 

(def-411-trap newhandle :number
  '41250
  :entry
  '((:d0 (logicalsize long word)))
  :exit
  '((:a0 (function result handle)) (:d0 (result code word)))) 

(def-411-trap syserror :number
  '43465
  :entry
  '((:d0 (errorcode word)))
  :exit
  'nil) 

(def-411-trap readdatetime :number
  '41017
  :entry
  '((:a0 (pointer to long word secs)))
  :exit
  '((:a0 (pointer to long word secs)) (:d0 (result code word)))) 

(def-411-trap attachvbl :number
  '41073
  :entry
  '((:d0 (theslot word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap ptrzone :number
  '41288
  :entry
  '((:a0 (p pointer)))
  :exit
  '((:a0 (function result pointer)) (:d0 (result code word)))) 

(def-411-trap ptrtoxhand :number
  '43490
  :entry
  '((:a0 (srcptr pointer)) (:a1 (dsthndl handle)) (:d0 (size long word)))
  :exit
  '((:a0 (dsthndl handle)) (:d0 (result code word)))) 

(def-411-trap sethandlesize :number
  '40996
  :entry
  '((:a0 (h handle)) (:d0 (newsize long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap ppostevent :number
  '41263
  :entry
  '((:a0 (eventcode word)) (:d0 (eventmsg long word)))
  :exit
  '((:a0 (pointer to event queue entry)))) 

(def-411-trap delay :number
  '41019
  :entry
  '((:a0 (numticks long word)))
  :exit
  '((:d0 (finalticks long word)))) 

(def-411-trap setappllimit :number
  '41005
  :entry
  '((:a0 (zonelimit pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap hgetstate :number
  '41065
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (flags byte)))) 

(def-411-trap newemptyhandle :number
  '41318
  :entry
  'nil
  :exit
  '((:a0 (function result handle)) (:d0 (result code word)))) 

(def-411-trap getfpos :number '40984 :entry 'nil :exit 'nil) 

(def-411-trap dtinstall :number
  '41090
  :entry
  '((:a0 (dttaskptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap sysenvirons :number '41104 :entry 'nil :exit 'nil) 

(def-411-trap writeparam :number
  '41016
  :entry
  '((:a0 (sysparam pointer)) (:d0 (minusone long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap setptrsize :number
  '40992
  :entry
  '((:a0 (p pointer)) (:d0 (newsize long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap stackspace :number
  '41061
  :entry
  'nil
  :exit
  '((:d0 (function result word)))) 

(def-411-trap maxblock :number
  '41057
  :entry
  'nil
  :exit
  '((:d0 (function result word)))) 

(def-411-trap oseventavail :number
  '41008
  :entry
  '((:a0 (pointer to event record theevent)) (:d0 (eventmask word)))
  :exit
  '((:d0 (0 if non-null event returned or \1 if null event)))) 

(def-411-trap stripaddress :number
  '41045
  :entry
  '((:d0 (theaddress pointer)))
  :exit
  '((:d0 (function result pointer)))) 

(def-411-trap vremove :number
  '41012
  :entry
  '((:a0 (vbltaskptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap geteof :number '40977 :entry 'nil :exit 'nil) 

(def-411-trap handandhand :number
  '43492
  :entry
  '((:a0 (ahndl handle)) (:a1 (bhndl handle)))
  :exit
  '((:a0 (bhndl handle)) (:d0 (result code word)))) 

(def-411-trap disposptr :number
  '40991
  :entry
  '((:a0 (p pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap resrvmem :number
  '41024
  :entry
  '((:d0 (cbneeded long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap sintremove :number
  '41078
  :entry
  '((:d0 (slot number word)) (:a0 (address of slot queue element)))
  :exit
  '((:d0 (error code)))) 

(def-411-trap nminstall :number
  '41054
  :entry
  '((:d0 (low-order word #\: eventmask)))
  :exit
  '((:d0 (0 or event code word)))) 

(def-411-trap dovbltask :number
  '41074
  :entry
  '((:d0 (theslot word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap primetime :number
  '41050
  :entry
  '((:a0 (tmtaskptr pointer)) (:d0 (count long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap getosdefault :number '41092 :entry 'nil :exit 'nil) 

(def-411-trap ptrtohand :number
  '43491
  :entry
  '((:a0 (srcptr pointer)) (:d0 (size long word)))
  :exit
  '((:a0 (dsthndl handle)) (:d0 (result code word)))) 

(def-411-trap hnopurge :number
  '41034
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap setadbinfo :number
  '41082
  :entry
  '((:a0 (pointer to parameter block)) (:d0 (adb address of the device byte)))
  :exit
  '((:d0 (result code byte)))) 

(def-411-trap maxmem :number
  '41245
  :entry
  'nil
  :exit
  '((:d0 (function result long word)) (:a0 (grow long word)))) 

(def-411-trap setzone :number
  '40987
  :entry
  '((:a0 (hz pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap disposhandle :number
  '40995
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap gethandlesize :number
  '40997
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (if >= 0 function result long word)))) 

(def-411-trap adddrive :number '41038 :entry 'nil :exit 'nil) 

(def-411-trap hlock :number
  '41001
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap swapmmumode :number
  '41053
  :entry
  '((:d0 (mode byte)))
  :exit
  '((:d0 (mode byte)))) 

(def-411-trap getindadb :number
  '41080
  :entry
  '((:a0 (pointer to parameter block))
    (:d0 (entry index number #\; range = 1 countadbs byte)))
  :exit
  '((:d0 (positive value #\: current adb address byte)))) 

(def-411-trap getadbinfo :number
  '41081
  :entry
  '((:a0 (pointer to parameter block)) (:d0 (adb address of the device byte)))
  :exit
  '((:d0 (result code byte)))) 

(def-411-trap hsetstate :number
  '41066
  :entry
  '((:a0 (h handle)) (:d0 (flags byte)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap reallochandle :number
  '40999
  :entry
  '((:a0 (h handle)) (:d0 (logicalsize long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap hsetrbit :number
  '41063
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap setdefaultstartup :number '41086 :entry 'nil :exit 'nil) 

(def-411-trap adbop :number
  '41084
  :entry
  '((:a0 (pointer to parameter block)) (:d0 (commandnum byte)))
  :exit
  '((:d0 (result code byte)))) 

(def-411-trap uprstring :number '41044 :entry 'nil :exit 'nil) 

(def-411-trap setfpos :number '41028 :entry 'nil :exit 'nil) 

(def-411-trap enqueue :number
  '43375
  :entry
  '((:a0 (qentry pointer)) (:a1 (thequeue pointer)))
  :exit
  '((:a1 (thequeue pointer)))) 

(def-411-trap instime :number
  '41048
  :entry
  '((:a0 (tmtaskptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap setgrowzone :number
  '41035
  :entry
  '((:a0 (growzone pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap purgemem :number
  '41037
  :entry
  '((:d0 (cbneeded long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap recoverhandle :number
  '41256
  :entry
  '((:a0 (p pointer)))
  :exit
  '((:a0 (function result handle)) (:d0 (unchanged)))) 

(def-411-trap movehhi :number
  '41060
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap ptrandhand :number
  '43503
  :entry
  '((:a0 (pntr pointer)) (:a1 (hndl handle)) (:d0 (size long word)))
  :exit
  '((:a0 (hndl handle)) (:d0 (result code word)))) 

(def-411-trap rename :number '40971 :entry 'nil :exit 'nil) 

(def-411-trap freemem :number
  '40988
  :entry
  'nil
  :exit
  '((:d0 (function result long word)))) 

(def-411-trap purgespace :number
  '41314
  :entry
  'nil
  :exit
  '((:a0 (contig long word)) (:d0 (total long word)))) 

(def-411-trap vinstall :number
  '41011
  :entry
  '((:a0 (vbltaskptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap eject :number '40983 :entry 'nil :exit 'nil) 

(def-411-trap seteof :number '40978 :entry 'nil :exit 'nil) 

(def-411-trap handtohand :number
  '43489
  :entry
  '((:a0 (thehndl handle)))
  :exit
  '((:a0 (thehndl handle)) (:d0 (result code word)))) 

(def-411-trap secs2date :number
  '43462
  :entry
  '((:d0 (secs long word)))
  :exit
  '((:a0 (pointer to date/time record)))) 

(def-411-trap setdatetime :number
  '41018
  :entry
  '((:d0 (secs long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap getosevent :number
  '41009
  :entry
  '((:a0 (pointer to event record theevent)) (:d0 (eventmask word)))
  :exit
  '((:d0 (0 if non-null event returned or \1 if null event)))) 

(def-411-trap setvideodefault :number '41089 :entry 'nil :exit 'nil) 

(def-411-trap status :number '40965 :entry 'nil :exit 'nil) 

(def-411-trap compactmem :number
  '41036
  :entry
  '((:d0 (cbneeded long word)))
  :exit
  '((:d0 (function result long word)))) 

(def-411-trap getptrsize :number
  '40993
  :entry
  '((:a0 (p pointer)))
  :exit
  '((:d0 (if >= 0 function result long word)))) 

(def-411-trap hpurge :number
  '41033
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap slotvinstall :number
  '41071
  :entry
  '((:a0 (vbltaskptr pointer)) (:d0 (theslot word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap hclrrbit :number
  '41064
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap settrapaddress :number
  '41031
  :entry
  '((:a0 (trapaddr address)) (:d0 (trapnum word)))
  :exit
  'nil) 

(def-411-trap setapplbase :number
  '41047
  :entry
  '((:a0 (startptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap slotvremove :number
  '41072
  :entry
  '((:a0 (vbltaskptr pointer)) (:d0 (theslot word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap control :number '40964 :entry 'nil :exit 'nil) 

(def-411-trap initutil :number
  '41023
  :entry
  'nil
  :exit
  '((:d0 (result code word)))) 

(def-411-trap setosdefault :number '41091 :entry 'nil :exit 'nil) 

(def-411-trap alloccontig :number '41488 :entry 'nil :exit 'nil) 

(def-411-trap hunlock :number
  '41002
  :entry
  '((:a0 (h handle)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap blockmove :number
  '41006
  :entry
  '((:a0 (sourceptr pointer)) (:a1 (destptr pointer))
    (:d0 (bytecount long word)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap relstring :number '41040 :entry 'nil :exit 'nil) 

(def-411-trap sintinstall :number
  '41077
  :entry
  '((:d0 (slot number word)) (:a0 (address of slot queue element)))
  :exit
  '((:d0 (error code)))) 

(def-411-trap dequeue :number
  '43374
  :entry
  '((:a0 (qentry pointer)) (:a1 (thequeue pointer)))
  :exit
  '((:a1 (thequeue pointer)) (:d0 (result code word)))) 

(def-411-trap newptr :number
  '41246
  :entry
  '((:d0 (logicalsize long word)))
  :exit
  '((:a0 (function result pointer)) (:d0 (result code word)))) 

(def-411-trap date2secs :number
  '43463
  :entry
  '((:a0 (pointer to date/time record)))
  :exit
  '((:d0 (secs long word)))) 

(def-411-trap countadbs :number
  '41079
  :entry
  'nil
  :exit
  '((:d0 (number of devices byte)))) 

(def-411-trap create :number '40968 :entry 'nil :exit 'nil) 

(def-411-trap getzone :number
  '41242
  :entry
  'nil
  :exit
  '((:a0 (function result pointer)) (:d0 (result code word)))) 

(def-411-trap initzone :number
  '40985
  :entry
  '((:a0 (pointer to parameter block)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap rmvtime :number
  '41049
  :entry
  '((:a0 (tmtaskptr pointer)))
  :exit
  '((:d0 (result code word)))) 

(def-411-trap getdefaultstartup :number '41085 :entry 'nil :exit 'nil) 

(def-411-trap emptyhandle :number
  '41003
  :entry
  '((:a0 (h handle)))
  :exit
  '((:a0 (h handle)) (:d0 (result code word)))) 

(def-411-trap postevent :number
  '41007
  :entry
  '((:a0 (eventcode word)) (:d0 (eventmsg long word)))
  :exit
  '((:d0 (result code word)))) 
