{***********************************************************

Created: Monday, February 8, 1993 at 7:35PM
 OCEErrors.p
 Pascal Interface to the Macintosh Libraries

	 Apple Confidential 
	 Provided with AOCE Beta seed under license agreement with   
	 Apple Computer, Inc.  Use for any purpose other than        
	 development of AOCE-based Macintosh products is a violation 
	 of the license agreement.                                   

  Copyright Apple Computer, Inc. 1990-1993
  All rights reserved

***********************************************************}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes:= 0}
{$ENDC}

{$IFC NOT UsingIncludes}
	UNIT OCEErrors;
	INTERFACE
{$ENDC}

{$IFC UNDEFINED UsingOCEErrors}
{$SETC UsingOCEErrors:= 1}

{$I+}
{$SETC OCEErrorsIncludes:= UsingIncludes}
{$SETC UsingIncludes:= 1}


{$IFC UNDEFINED UsingTypes}
{$I $$Shell(PInterfaces)Types.p}
{$ENDC}

{$IFC UNDEFINED UsingErrors}
{$I $$Shell(PInterfaces)Errors.p}
{$ENDC}

{$SETC UsingIncludes:= OCEErrorsIncludes}




{ Errors specific to controlling the OCE toolbox. }

CONST
collabTBHasPendingMsgs			= -30000;		{ Temp. err number }
collabTBInvalidConfiguration	= -29999;

{
Allocated ranges:
	Mail and Messaging						-1500 to -1620
	Naming and Authentication				-1621 to -1680
	Collab Package  (Letter Send Package)	-1900 to -1939
	Digital Signature						-1940 to -1999
}

kOCEFIRSTError = -7999;					{ merely a placeholder }
kOCENotLocal = -7998;
kOCELocal = -7997;
kOCENewFailed = -7996;
kOCENoSuchAttrID = -7995;
kOCENoDupAllowed = -7994;
kOCEValueExists = -7993;
kOCEUnsupportedValueType = -7992;
kOCENoSuchCluster = -7991;
kOCEOutOfTime = -7988;
kOCETooBusy = -7987;						{ server cannot complete call at this time }
kOCEOtherTooBusy = -7986;					{ another server needed to complete request was too busy }
kOCEDatabaseFull = -7985;
kOCETimeClash = -7984;
kOCECredentialsUntrusted = -7983;
kOCEReadAccessDenied = -7980;
kOCEWriteAccessDenied = -7979;
kOCEClusterUnavailable = -7978;
kOCEClusterUntrusted = -7977;
kOCENameDoesntMatchCID = -7976;
kOCETypeDoesntMatchCID = -7975;
kOCECantReachAnyDirectory = -7974;
kOCETargetDirectoryInaccessible = -7973;	{ Directory server not responding }
kOCEAuthenticationTrouble = -7972;			{ catch-all for misc auth errors }
kOCEBadPattern = -7971;						{ incorrect use of wildcards in Enumerate }
kOCEBadRecordID = -7970;					{ invalid RecordID }
kOCEParamErr = -7969;						{ invalid parameter passed to toolbox }
kOCENoSuchAttribute = -7967;
kOCENoSuchRecord = -7966;
kOCENoSuchValue = -7965;
kOCEBadAttribute = -7964;
kOCEAttributeValueTooBig = -7963;
kOCETbClosing = -7962;						{ toolbox is in the process of closing }
kOCETbInvalidCommand = -7961;				{ bad request code passed to toolbox }
kOCETbInternalErr = -7960;					{ catch-all for misc errors }
kOCEDBVersionsDifferent = -7959;
kOCEMoreData = -7958;						{ warning - buffer not big enough }
kOCERLIsDontMatch = -7957;					{ lookup failed because RLIs are different }
kOCERefNumBad = -7956;						{ RefNum is not good }
kOCEStreamCreationErr = -7955;				{ problem creating stream }
kOCERPCVersionErr = -7954;					{ problem in RPC Version Exchange }
kOCEBadStartingRecord = -7953;				{ Lookup starting record is not within range }
kOCEBadStartingAttribute = -7952;			{ Lookup starting record is not within range }
kOCEMoreAttrValue = -7951;					{ attribute value could not fit into buffer (even though it was the only value) }
kOCEOpenPermissionConflict = -7950;			{ PAB could not be opened with the requested permission }
kOCEOperationNotSupported = -7949;			{ the specified directory does not support this operation }
kOCEPABNotOpen = -7948;						{ specified PAB is not open to make the operation }
kOCEDASHInstallErr = -7947;					{ specified DASH could not be installed }
kOCEDirListFullErr = -7946;					{ directory list is full, try removing an entry }
kOCEDirectoryNotFoundErr = -7945;			{ directory was not found in the list }
kOCEInvalidDirRefErr = -7944;				{ bad Directory reference }
kOCECredentialsInvalid = -7943;				{ credentials are not valid }
kOCECredentialsExpired = -7942;				{ current time > expiry time }
kOCEAccessRightsInsufficient = -7941;		{ authorization failure }
kOCECredentialsProblem = -7940;				{ miscellaneous problem with credentials }
kOCENoKeyFound = -7939;						{ found no key for entity in question }
kOCEPrincipalKeyNotFound = -7938;			{ self-explanatory }
kOCERecipientKeyNotFound = -7937;			{ self-explanatory }
kOCEAgentKeyNotFound = -7936;				{ self-explanatory }
kOCEUnsupportedCredentialsVersion = -7935;	{ self-explanatory }
kOCEUndefinedCallProblem = -7934;			{ problem going server-to-server }
kOCEKeyAlreadyRegistered = -7933;			{ entity already has a key }
kOCEMalformedKey = -7932;					{ doesn't look good }
kOCEUndesirableKey = -7931;					{ might be a bad key or too easy to guess }
kOCEProxyImmature = -7930;					{ current time < proxy start time }
kOCEProxyExpired = -7929;					{ current time > proxy expiry time }
kOCEDisallowedRecipient = -7928;			{ Recipient not specified in proxy }
kOCEUselessExpiry = -7927;					{ current time > expiry time }
kOCENoAcceptableRecipients = -7926;			{ record for intended recipient doesn't exist }
kOCEWrongIdentityOrKey = -7925;				{ name doesn't exist or key is wrong }
kOCETooDeep = -7924;						{ trying to nest a DNode too deep }
kOCEClusterAlreadyLocal = -7923;			{ trying to create a replica that already exists }
kOCEInitiatorKeyProblem = -7922;			{ some problem with initiator's key }
kOCEAbortNotSupportedForThisCall = -7921;	{ This call cannot be aborted }
kOCEAborted = -7920;						{ This call was aborted }
kOCELocalIdentityNotExists  = -7919;		{ LocalIdentity has to be unlocked }
kOCEOCESetupRequired= -7918;				{ LocalIdentity Setup is required }
kOCELocalIdentityNotSetup= -7917;			{ LocalIdentity Setup is required before changing }
kOCELocalAuthenticationFail= -7916;			{ LocalIdentity Login has to be done for this operation }
kOCELocalIdentitySetupExists= -7915;		{ LocalIdentity setup exists, use change  instead setup }
kOCEDirectoryIdentitySetupExists= -7914;  	{ DirectoryIdentity setup exists, use change  instead setup }
kOCEDirectoryIdentitySetupNotExists= -7913;	{ DirectoryIdentity setup exists, use change  instead setup }
kOCENotLocalIdentity	= -7912;			{ Use LocalIdentity calls instead! }
kOCEDSAMRecordNotFound	= -7911;			{ DSAM Record Not found }
kOCEDSAMNotInstantiated	= -7910;			{ DSAM is not instantiated }
kOCEDSAMRecordExists = -7909;				{ DSAM Record already exists }
kOCENotMasterPathFinder = -7800;			{ Add/Delete Child not done on Master Pathfinder }
kOCEBogusArgs = -7700;						{ DSAM is not instantiated }
kOCEPfNotAvailable = -7505;					{ PathFinder error codes }
kOCEPfNodeExists = -7504;
kOCEPfInvalidReach = -7503;
kOCEPfInvalidForwarderRLI = -7502;
kOCEPfNoSuchNode = -7501;
kOCEPfPathNotFound = -7500;
kOCEPfHasReplicas = -7499;					{ Can't delete child because replicas exist }
kOCELASTError = -7000;						{ merely a placeholder }
kOCENoMoreIDs = -1622;						{ identity table full }
kOCEUnknownID = -1623;						{ identity passed is not valid }
kOCELengthError = -1627;					{ supplied buffer was too small }
kOCEBadADSPocMode = -1643;
kOCENoASDSPWorkSpace = -1644;
kOCEAmbiguousMatches = -1646;
kOCEOperationDenied = -1650;
kOCEDisableIdentityInEffect = -1651;
kOCEInstallErr = -1653;
kOCERemoveErr = -1654;
kOCEBadEncryptionMethod = -1655;
kOCETimeServiceFail = -1657;
kOCEMiscError = -1633;						{ some other error }

{ !!! are the following duplicates or obsolete? }
kOCENoAgents = -1629;						{ we don't support agents in this release }
kOCEAuthSeviceError = -1641;
kOCEStreamError = -1642;
kOCEPrincipalNameUnknown = -1647;
kOCERecipientNameUnknown = -1648;
kOCEAgentNameUnknown = -1649;
kOCEIncorrectIdentityOrKey = -1656;




{
	Currently returned error codes.  Naming and Authentication have
	reserved the range -1621 to -1680.
}
daNoGlobals					= -1621;		{ no memory for globals, or no ASInit made }
daNoMoreIDs					= -1622;		{ identity table full }
daUnknownID					= -1623;		{ identity passed is not valid }
daAccessDenied				= -1624;
daBadKey					= -1625;		{ key format is invalid }
daAuthFailed				= -1626;		{ a challenge reply was wrong }
daLengthError				= -1627;		{ supplied buffer was too small }
daVersionErr				= -1628;		{ can't handle version of credentials }
daNoAgents					= -1629;		{ we don't support agents in this release }
daBadName					= -1630;		{ invalid name format }
daBadCreds					= -1631;		{ credentials don't make sense }
daServerNotFnd				= -1632;		{ can't find an Auth Server }
daMiscError					= -1633;		{ some other error }
daServerBusy				= -1634;		{ some server was too busy }
daUnknownName				= -1635;		{ a name (RecordID) not in database }
daExpired					= -1636;		{ proxy expired -- check clocks }
daTooSoon					= -1637;		{ proxy not yet valid -- check clocks }
daKeyNotFound				= -1638;		{ no such key registered }
daKeyExists					= -1639;		{ key already exists (CreateKey) }

daInvalidCommand 			= -1640;
daAuthSeviceError			= -1641;
daStreamError 	  			= -1642;

daBadADSPocMode   			= -1643;
daNoASDSPWorkSpace  		= -1644;
daASMoreData  	  			= -1645;
daAmbiguousMatches  	  	= -1646;
daPrincipalNameUnknown  	= -1647;
daRecipientNameUnknown  	= -1648;
daAgentNameUnknown  	    = -1649;
daOperationDenied			= -1650;
daDisableIdentityInEffect   = -1651;
daIdentityExists  			= -1652;
daInstallErr  				= -1653;
daRemoveErr  				= -1654;
daBadEncryptionMethod  		= -1655;
daIncorrectIdentityOrKey  	= -1656;
daTimeServiceFail  			= -1657;

{ All groups fo functions may return these errors defined in Errors.h. }
{ paramErr }


{ All groups fo functions may return these errors. }
{ -6000 was picked arb. - need to fix it up }
kOCEToolboxNotOpen		= -1591;		{ Toolbox not open; perhaps its closing }
kOCEInvalidCommand		= -1592;		{ Request code passed to a trap call is invalid }
kOCEInvalidRef			= -6000;		{ a reference to an object is obsolete or invalid }
kOCEBufferTooSmall		= -5999;		{ the buffer supplied is too small for the task }
kOCEVersionErr			= -5998;		{ some manner of software version mismatch }
kOCESyncAsyncErr		= -5997;		{ Op tried synchronously may only be done async, or vice versa }
kOCEInternalErr			= -5996;		{ the OCE toolbox has an internal error }
kOCENotAnOwner			= -5995;		{ this operation can only be done by the object's owner }
kOCENotImplemented		= -5994;		{ Feature not implemented }
kOCENotAuthenticated	= -5993;		{ The user must be authenticated }
kOCEAlreadyExists		= -5992;		{ The object being added already exists }
kOCEDoesntExist			= -5991;		{ the object being referenced doesn't exist or cannot be found }
kOCEConnectionErr		= -5990;		{ Unable to open or maintain a network transport }
kOCEConnectionClosed	= -5989;		{ Connect has closed }




{ Messaging }
kIPMCantCreateIPMCatEntry	= -1501;
kIPMInvalidPriority = -1506;			{ bad priority value }
kIPMInvalidMsgType = -1507;				{ bad msg hint }
kIPMInvalidProcHint = -1508;			{ bad proc hint }
kIPMInvalidOffset = -1514;				{ bad offset for read/write }
kIPMUpdateCatFailed			= -1509;
kOCEInvalidRecipient = -1510;			{ Invalid recipient/address for this command }
kIPMMsgTypeReserved			= -1511;
kIPMNotInABlock				= -1512;
kIPMNestedMsgOpened			= -1516;
kIPMCantCreateIPMFldr		= -1518;
kIPMA1HdrCorrupt			= -1519;
kIPMCorruptDataStructures	= -1520;
kIPMAbortOfNestedMsg		= -1521;
kOCEInvalidIndex			= -1523;	{ invalid index (out of range) }
kIPMBlockIsNotNestedMsg		= -1525;
kOCERefIsClosing			= -1527;	{ Object references is being closed, cannot complete command }
kIPMCacheFillError			= -1529;
kIPMInvalidSender			= -1531;
kIPMNoRecipientsYet			= -1532;
kIPMInvalidFilter			= -1533;
kIPMAttrNotInHdr			= -1534;
kIPMBlkNotFound				= -1535;
kIPMMsgExpired				= -1568;
kIPMMsgNotExist				= -1569;	{ the msg is been move to defq then deleted }
kIPMStreamErr				= -1570;	{ Error on stream (should this ever go out?) }
kIPMPortClosed				= -1571;	{ Port closed (should this ever go out?) }


{
We need to rename this errors in some clean way
}
qBinBusy			= (-1560);
qBinExists			= (kOCEAlreadyExists);
qBinNotFound		= (kOCEDoesntExist);
qCorruptedBin		= (-1557);
qBadQName			= (-1556);
qEndOfBin			= (-1555);
qQueueExists		= (kOCEAlreadyExists);
qBinNeedsConversion	= (-1553);
qMgrInternalErr 	= (-1552);
qEltBusy			= (-1551);
qQNotFound			= (kOCEDoesntExist);
qEltClosedNotDeleted	= (-1549);
qBadContext			= (-1548);
qContextIsClosing	= (-1547);
qeoQ				= (-1546);
qEltRdOnly			= (kOCEWriteAccessDenied);
qQOutOfSpace		= (-1544);
qEltNotFound		= (-1543);
qBinOutOfSpace		= (-1542);
qeoCatEntry			= (-1541);
qeoElt				= (-1540);
qQBusy				= (-1539);
qNotSameBin			= (-1538);
qNotModifiable		= (kOCEWriteAccessDenied);
qOpNotImplemented	= (kOCENotImplemented);

kMailOffsetNonZeroErr		= -1565;	{ temporary, says that ReadAttributeOffset cannot }
kMailInvalidOrder			= -1567;	{ This object has already been written to and cannot be written again }
{ handle non-zero offsets for now }
kMailInvalidSeqNum			= -1568;	{ Invalid letter sequence o refers to an nonexistent letter }
kMailAttrNotInHdr			= -1570;	{ attribute does not exist in this letter header }
kMailNotFixedLenAttr		= -1572;	{ ?? check this }
kMailHdrAttrMissing			= -1575;	{ required attribute not written into letter header }
kMailWriteActCountErr		= -1576;	{ ?? check this }
kMailBadEnclLengthErr		= -1579;	{ incorrect number of bytes has been written after memForm of PutEnclosure }
kMailNoServerSlotErr		= -23001;	{ cannot do autoActions - no server slot exists }
kMailInvalidRequest			= -23002;	{ cannot putAttr for report, putRcptReport for letter }
kMailInvalidPostItVersion	= -23004;	{ cannot create new postit with this version }
kMailNotASlotInQ			= -23005;	{ queueID does not refer to a slot's incoming queue }
kMailLtrNotOpen				= -23006;	{ letter is not open, probably not cached in inQ }
kMailMissingMailCat			= -23008;	{ trying to create message in inq, with no postIt }
kMailCannotWriteMailCat		= -23009;	{ cannot update a mail catentry }
kMailTooManyTagsPerLetter	= -23010;	{ cannot add more than kMaxTagsPerLetter tags }

{ cck = backwards, }
kMailGwyDead				= -1580;	{ mash died }
kMailIgnoredErr				= -1581;	{ ePPC message was ignored }
kMailLengthErr				= -1582;	{ ePPC message did not complete }
kMailTooManyErr				= -1583;	{ Too many = request outstanding, }
kMailNoMaSHErr				= -1585;	{ no mashes found in mailbox! or for command }
kMailDupMaSHErr				= -1587;	{ duplicate mash found in mailbox }
kMailCancelled				= kMailTooManyErr;

{ /amXFSBusy				= -1595;		xfs is busy within mailbox/ltr }
kMailSlotSuspended			= -1595;
kMailMaSHSuspended			= -1596;
kMailBadSlotInfo			= -1597;



{ Letter Content }
	{ The name of this misleading, this will be returned if: }
	{ no header, bad header, bad header version, bad content }
kMailMalformedContent		= -1593;	{ a mailed structure is malformed }


kMailNoSuchSlot				= -21001;	{ no such slot }
kMailBadLtrInfo				= -21002;	{ bad info there, can't change }
kMailSetFailed				= -21003;	{ could not set letter info }
kMailBadConfig				= -21004;	{ mash has bad config info }
kMailUnknownMaSH			= -21005;	{ spec. mash is not known }
kMailUnknownMailSlot		= -21006;	{ spec. mail slot is not known }
kMailBadMaSH				= -21007;	{ bad mash: not usable = reason unspec, }
kMailCannotOpenSlot			= -21008;	{ cannot open mail slot }
kMailCannotLkupServerSlots	= -21009;	{ cannot lookup adas for server mail slots }

{ some errors for addressing }
{ invalid name at ipm & mail levels should combine at user level }
amBadDestId					= kOCEInvalidRecipient;		{ historical, keep for a bit }
kMailNumRoutingPts			= -21010;	{ bad m&m destid, wrong #of routing parts }
kMailNoDest2Rid				= -21011;	{ RID cannot be formed from given destid }
kMailRequiresServer			= -21013;	{ address requires serverbased environment }

{ GWSetStatus }
kMailBadState				= -21016;	{ the state specifiy is not in any of defined }


{ authutils errors }
eAUNoAttrsFound				= -22001;	{ couldn't find any attrs in lookup }
eAUWrongAttrTag				= -22002;	{ wrong attr tag in adas lookup }
eAUNullCID					= -22003;	{ null cid in enumerate }
eAUBadMailSlotAttrVal		= -22004;	{ invalid mailslot attr value }
eAULookupAttrTooBig			= -22005;	{ attribute in lookup is too big }


{ follow errors are extracted, may NOT be complete }
{ ipm errors }
{ CCK: Not at all clear that any of these errors should
       be allowed to show up at the API }
kIPMNoMoreServices			= -24002;
kIPMBadContext				= -24004;
kIPMUnknownUAM				= -24006;
kIPMUnsupportedLogin		= -24007;
kIPMLogInUnknown			= -24012;
kIPMNoMoreFilters			= -24013;
kIPMCouldNotReadInfoReply	= -24017;
kIPMInvalidUser				= -24018;
kIPMNoMoreSessions			= -24019;
kIPMNilUserProc				= -24021;
kIPMBadCatSize				= -24022;
kIPMIncompleteMsg			= -24023;
kIPMNoResponsibleTunnel		= -24024;
kIPMAccessDenied			= -24026;
kIPMReplyParamUnderrun		= -24008;	{ Too few reply parameters }
kIPMReplyParamOverrun		= -24009;	{ Too many reply parameters }
kIPMRequestParamUnderrun	= -24025;	{ Too few request parameters }
kIPMOutOfSync				= -24011;	{ Protocol sync. error }





Dialup_err_base					= -9000;
ERR_LINKTOOLNOTFOUND			= Dialup_err_base;		{  -9000 }
Dialup_MessageNotACKed			= Dialup_err_base-1;	{  -9001 the receiving side does not ack the msg }
{  bt file }
BTNameResNotFound				= Dialup_err_base-2;	{  -9002 in OpenBT can not get bt name str# resource }
eCanNotGetDialupSlotAttrValue	= Dialup_err_base-3;	{  -9003 when look up to ADAP MnMServer Rec, can not get dialupslotinfo attr }
eDialToSelf						= Dialup_err_base-4;	{  -9004 trying to dial to it's own phon num }




{ Errors specific to routines of OCEStandardDirectory.h }
kSDPNoSearchText 				= -1906;
kSDPTooManyLoginAttempts 		= -1907;



{ Errors specific to routines of OCEStandardMail.h }
kSMPNotEnoughMemoryForAllRecips 		= -1914;
kSMPCopyInProgress		 				= -1915;
kSMPNoSelection 						= -1916;
kSMPMailerNotInitialized 				= -1917;
kSMPShouldNotAddContent 				= -1918;
kSMPMailboxNotFound 					= -1919;
kSMPNoNextLetter	 					= -1920;
kSMPHasOpenAttachments 					= -1921;
kSMPFinderNotRunning					= -1922;
kSMPCommandDisabled						= -1925;
kSMPNoMailerInWindow					= -1926;
kSMPNoSuchAddress						= -1927;
kSMPMailerAlreadyInWindow				= -1928;
kSMPMailerUneditable					= -1929;
kSMPNoMatchingBegin						= -1930;
kSMPCannotSendReceivedLetter			= -1931;
kSMPIllegalForDraftLetter				= -1932;
kSMPMailerCannotExpandOrContract		= -1933;
kSMPMailerAlreadyExpandedOrContracted	= -1934;
kSMPIllegalComponent					= -1935;
kSMPMailerAlreadyNotTarget				= -1936;
kSMPComponentIsAlreadyTarget			= -1937;
kSMPRecordDoesNotContainAddress			= -1938;
kSMPAddressAlreadyInList				= -1939;
kSMPIllegalSendFormats					= -1940;
kSMPInvalidAddressString 				= -1941;
kSMPSubjectTooBig		 				= -1942;
kSMPParamCountErr						= -1943;	{  enclosure count != 1, while sendEnclosure Only == true. }
kSMPTooManyPages 						= -1944;	{  Exceeding the image page limit. }


{ Codes specific to DigitalSignature.h }
DigitalSignature_Err 			= -1950;
kSIGOperationIncompatibleErr 	= DigitalSignature_Err;		{ context in use for different type of operation }
kSIGUserCanceled 				= DigitalSignature_Err-1;	{ user clicked cancel in dialog box }
kSIGVerifyFailedErr 			= DigitalSignature_Err-2;	{ verification failed }
kSIGInvalidCredentialErr 		= DigitalSignature_Err-3;	{ verified OK but credential out of date,  either pending or expired }
kSIGIndexErr 					= DigitalSignature_Err-4;	{ the index given is outside the range of allowable values }
kSIGSignerErr 					= DigitalSignature_Err-5;	{ problem with the signer or signature itself }
kSIGPasswordErr 				= DigitalSignature_Err-6;	{ password is incorrect }
kSIGInternalsErr 				= DigitalSignature_Err-7;	{ an internal error occurred like a bad digest, context or signature }
kSIGToolboxNotPresentErr 		= DigitalSignature_Err-8;	{ for client services (servers: ie) to report back - not retruned by the TB }
kSIGContextPrepareErr 			= DigitalSignature_Err-9;	{ context either prepared with VerifyPrepare, SignPrepare or DigestPrepare already or has been corrupted }
kSIGNoDigestErr 				= DigitalSignature_Err-10;	{ no digest in the signature }
kSIGConversionErr 				= DigitalSignature_Err-11;	{ unabled to convert an attribute to Mac format }
kSIGSignerNotValidErr 			= DigitalSignature_Err-12;	{ Signer has either expired or is pending and can not sign }
kSIGNoSignature 				= DigitalSignature_Err-13;	{ standard file signature not found }


{	The following errors are returned only in response to DE template call-backs. In addition to these errors,
	it is possible to get Memory Manager errors returned. }

CONST
kDETInvalidTargetAspectName = -1970;	{ Could not locate an aspect by name }
kDETInvalidTargetItemNumber = -1971;	{ Item number is target invalid (out of range 1..<number of children>) }
kDETInvalidTargetFromNonAspect = -1972;	{ Target selection relative to non-aspect object which requires an aspect }
kDETInvalidTargetDSSpec = -1973;		{ Target DSSpec could not be resolved }
kDETUnknownTargetSelector = -1974;		{ Unknown selector type for target specification }
kDETInvalidTarget = -1975;				{ Target specification was invalid (for reasons other than those above) }
kDETTargetNotAnAspect = -1976;			{ Specified target object was not an aspect }
kDETInvalidCommandItemNumber = -1977;	{ Command item number invalid (out of range 1..<number of items in selection>) }
kDETUnableToGetCommandItemSpec = -1978;	{ Unable to retrieve item specification (error: internal; possibly out of memory) }
kDETRequestedTypeUnavailable = -1979;	{ Command item could not be represented in the form requested }
kDETInvalidDSSpec = -1980;				{ Could not resolve DSSpec (other than in target; see error above for targets) }
kDETUnableToAccessProperty = -1981;		{ Property could not be found and/or created }
kDETInfoPageNotOpen = -1982;			{ Info-page not open; request requires an open info-page }
kDETNoSuchView = -1983;					{ No view found with specified property number }
kDETCouldNotAddMenuItem = -1984;		{ Could not add item to dynamic menu }
kDETCouldNotRemoveMenuItem = -1985;		{ Could not remove item from dynamic menu }
kDETCouldNotFindMenuItem = -1986;		{ Could not find menu item }
kDETCouldNotFindCustomView = -1987;		{ Could not find custom view in info-page }
kDETInvalidReqFunction = -1988;			{ Invalid call-back request function }
kDETInvalidCallBack = -1989;			{ Invalid call-back (for reasons other than those above) }



{$ENDC}    { UsingOCEErrors }

{$IFC NOT UsingIncludes}
    END.
{$ENDC}
