(in-package :traps)             ; 
; Created: Saturday, January 5, 1991 at 9:27 AM
;     Types.p
;     Pascal Interface to the Macintosh Libraries
; 
;         Copyright Apple Computer, Inc.    1985-1990
;         All rights reserved.
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingTypes
; $SETC UsingTypes := 1

; $IFC UNDEFINED SystemSixOrLater
; $SETC SystemSixOrLater := 0
; $ENDC
; $IFC UNDEFINED SystemSevenOrLater
; $SETC SystemSevenOrLater := 0
; $ENDC

(defconstant $noErr 0)          ; All is well
(defconstant $true -1)  ; Note!!! - use only for writing. Test true with (logbitp 0 x) in 
;                         a record and (logbit 8 x) for a stack value
(defconstant $false 0)

(def-mactype :integerptr (find-mactype :pointer))
(def-mactype :longintptr (find-mactype :pointer))
(def-mactype :fixed (find-mactype :signed-long));  fixed point arithmatic type 
(def-mactype :fixedptr (find-mactype :pointer))
(def-mactype :fract (find-mactype :signed-long))
(def-mactype :fractptr (find-mactype :pointer))

(def-mactype :vhselect (find-mactype :unsigned-byte))

(def-mactype :procptr (find-mactype :pointer));  pointer to a procedure 

(def-mactype :stringptr (find-mactype :pointer))
(def-mactype :stringhandle (find-mactype :handle))

(defrecord str255 
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 255)))

(defrecord str63 
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 63)))

(defrecord str32
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 32)))

(defrecord str31
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 31)))

(defrecord str27
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 27)))

(defrecord str15
  (length :unsigned-byte)
  (contents (:array :unsigned-byte 15)))

(def-mactype :oserr (find-mactype :signed-integer));  error code 

(def-mactype :ostypeptr (find-mactype :pointer))
(def-mactype :restype (find-mactype :ostype))
(def-mactype :restypeptr (find-mactype :pointer))
(def-mactype :scriptcode (find-mactype :signed-integer))
(def-mactype :langcode (find-mactype :signed-integer))

(def-mactype :pointptr (find-mactype :pointer))

(def-mactype :rectptr (find-mactype :pointer))
(defrecord Rect 
   (:variant 

      ((top :signed-integer)
      (left :signed-integer)
      (bottom :signed-integer)
      (right :signed-integer))

      ((topLeft :point)
       (:variant ((botRight :point))
                 ((bottomRight :point))))
      ))


(deftrap _debugger nil
   nil
   (:stack-trap #xA9FF))

(deftrap _debugstr ((astr (:string 255)))
   nil
   (:stack-trap #xABFF))

(deftrap _sysbreak nil
   nil
   (:stack-trap #xA9C9 :d0 65046))

(deftrap _sysbreakstr ((debugstr (:string 255)))
   nil
   (:stack-trap #xA9C9 :d0 65045 debugstr))

(deftrap _sysbreakfunc ((debugfunc (:string 255)))
   nil
   (:stack-trap #xA9C9 :d0 65044 debugfunc))

; $ENDC                         ;  UsingTypes 

; $IFC NOT UsingIncludes

; $ENDC


(export '($noerr $true $false))
(provide-interface 'Types)
